class AjaxIMConfig
  require 'yaml'
  
  def initialize(file)
    if !File.exist?(file)
      raise SystemCallError, "Configuration file does not exist!", caller[1..-1]
    end
    
    @config = YAML.load_file(file)
  end

  def [](key)
    get_value(key)
  end
  
  def method_missing(methId)
    call = methId.id2name
    get_value(call)
  end
  
  private
  def get_value(item)
    @config[item] if @config.has_key?(item)
  end
end