require 'mysql'

# We will hide ordinary query method in our Mysql child
# and create our own which will handle prefixes
class DrupalDB < Mysql
  attr_reader :prefix
  attr_writer :prefix
  alias_method :_query, :query
  private :_query

  # this method handles prefixes
  # and run ordinary query method
  def query(sql)
    _query(sql.strtr("{" => @prefix, "}" => ''))
  end
  
  def lock_table(table)
    query("LOCK TABLES #{escape_string(table)} WRITE")
  end
  
  def unlock_tables(table)
    _query('UNLOCK TABLES')
  end

  def next_id(table)
    query("LOCK TABLE {sequences} WRITE")
    res = query("SELECT id FROM {sequences} WHERE name = '{#{table}}'")
    if res.num_rows > 0
      id = res.fetch_hash['id'].to_i + 1
    else
      id = 0
    end
    query("REPLACE INTO {sequences} VALUES ('{#{table}}', #{id})")
    query("UNLOCK TABLES")
    id
  end
end